
%
%
% Demo of mutual information thresholding
%
%


N = 100; % image dimensions
SNR = 5; % signal-to-noise ratio

src = zeros(N,N);
Na = round(5*N/12);
Nb = round(7*N/12);
src(Na:Nb,Na:Nb) = 1;


src1 = abs(SNR*src + randn(N,N));
src2 = abs(SNR*src + randn(N,N));

subplot(1,2,1); shownormimage(src1);
title('Data Source 1');
subplot(1,2,2); shownormimage(src1);
title('Data Source 2');
pause

disp('Performing Mutual Information Thresholding...');
[T1, T2, mi, imT1, imT2, imF, quality, miscore] = mutualinfoThreshold(src1, src2);

disp(sprintf('Computed thresholds: T1=%2.3f, T2=%2.3f', T1, T2));
disp(sprintf('Agreement values: Mutual information=%2.3f, Quality=%2.3f', miscore, quality));

subplot(1,2,1); shownormimage(mi);
title('Mutual Information Surface');
subplot(2,2,2); shownormimage(imT1);
title('Source 1: Thresholded');
subplot(2,2,4); shownormimage(imT2);
title('Source 2: Thresholded');
pause



