function [mutinfo,a,b,c,d] = getmutualinfofast(im1, im2, mask)

if (nargin <= 2)
    mask=1;
end

im1 = removezeros(makelinear((im1+1000).*mask))-1000;
im2 = removezeros(makelinear((im2+1000).*mask))-1000;

imc = zeros(256,256,4);

L= length(im1);
for i = 1:L
    v1 = floor(im1(i));
    v2 = floor(im2(i));
    
    imc(1,1,1)=imc(1,1,1)+1;
    imc(v1+1,1,1)=imc(v1+1,1,1)-1;
    imc(1,v2+1,1)=imc(1,v2+1,1)-1;
    imc(v1+1,v2+1,1)=imc(v1+1,v2+1,1)+1;
    
    imc(1,v2+1,2)=imc(1,v2+1,2)+1;
    imc(v1+1,v2+1,2)=imc(v1+1,v2+1,2)-1;

    imc(v1+1,1,3)=imc(v1+1,1,3)+1;
    imc(v1+1,v2+1,3)=imc(v1+1,v2+1,3)-1;
    
    imc(v1+1,v2+1,4) = imc(v1+1,v2+1,4) + 1;
end

for i = 1:4
    imc(:,:,i) = integrate2db(imc(:,:,i));
end

a = imc(:,:,1)/L;
b = imc(:,:,2)/L;
c = imc(:,:,3)/L;
d = imc(:,:,4)/L;

ad = a+(a==0);
bd = b+(b==0);
cd = c+(c==0);
dd = d+(d==0);
cab = (a==0).*(b==0);
cac = (a==0).*(c==0);
cbc = (b==0).*(c==0);
cbd = (b==0).*(d==0);
ccd = (c==0).*(d==0);


% Mutual Information
mutinfo = a.*log(ad./(a+b+cab)./(a+c+cac)) + b.*log(bd./(a+b+cab)./(b+d+cbd)) + c.*log(cd./(a+c+cac)./(c+d+ccd)) + d.*log(dd./(c+d+ccd)./(b+d+cbd));
